//////////////////////
// Random text v1.0 //
//////////////////////

var targetObj;
var targetItem = 1;

// Start Up
function init(bricVersion)
{
	targetObj = $('[data-random-text="true"]');
	var max = targetObj.attr('data-random-text-string-count');
	window.webkit.messageHandlers.popUIMenu.postMessage('{"attr":"selected-string-item","items":"'+getMenuItemArray(max)+'", "value":"0"}'); // Set Menu Up
	window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"label-data","value":"'+targetObj.text()+'","sync":"false"}'); // Update Text Input Field
	window.webkit.messageHandlers.setUIHidden.postMessage('{"attr":"delete-btn","hidden":"true"}'); // Toggle Delete Button
}

// Set Type Face
function setTypeFace(typeFace)
{
	if (typeFace.indexOf(":")!= -1 ) // Font has a weight
	{
		var breakIndx = typeFace.indexOf(":");
		targetObj.css("font-family",typeFace.substring(0,breakIndx));
		targetObj.css("font-weight",typeFace.substring(breakIndx+1));
	}
	else // Simple Font
	{
		targetObj.css("font-family",typeFace);
	}
	
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Set Text Value
function setTextValue(value)
{
	if (targetItem == 1) // Set Initial Text String
	{
		targetObj.text(value);
	}
	else // Update data Attribute
	{
		targetObj.attr('data-random-text-string-'+targetItem,value);
	}

	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Set Text Color
function setTextAttribute(value,attr)
{
	targetObj.css(attr,value);
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Set Text Tag
function setTagType(tagValue,targetAttr)
{
	tagValue = parseInt(tagValue)+1;
	var newTag = 'h'+tagValue; // Default Headers

	if (tagValue == 7) // Paragraph
	{
		newTag = 'p';
	}
	else if (tagValue == 8) // Label
	{
		newTag = 'label';
	}

	var content = $('editarea').html();
	var currentTag = targetObj.prop('tagName').toLowerCase();

	content = content.replace('<'+currentTag,'<'+newTag).replace('</'+currentTag+'>','</'+newTag+'>');
	$('editarea').html(content);

	targetObj = $('[data-random-text="true"]'); // Re-assign Target Object

	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Set Selected Item
function setSelectedItem(tagValue,targetAttr)
{
	targetItem = parseInt(tagValue)+1;
	var stringVal = targetObj.text();

	if (targetAttr == 'Add New Item') // Add New Item
	{
		var newMax = parseInt(targetObj.attr('data-random-text-string-count'))+1;
		stringVal = 'New Text String';
		targetObj.attr('data-random-text-string-'+newMax,stringVal); // New Item
		targetObj.attr('data-random-text-string-count',newMax); // Store New Max
		window.webkit.messageHandlers.popUIMenu.postMessage('{"attr":"selected-string-item","items":"'+getMenuItemArray(newMax)+'", "value":"'+(newMax-1)+'"}');
		window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
	}
	else if (targetItem > 1) // Load Current
	{
		stringVal = targetObj.attr('data-random-text-string-'+targetItem);
	}

	stringVal = stringVal.replace(/"/g,'\\"'); // Escape Quotes
	
	// Update Text Input Field
	window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"label-data","value":"'+stringVal+'","sync":"false"}');

	// Toggle Delete Button
	window.webkit.messageHandlers.setUIHidden.postMessage('{"attr":"delete-btn","hidden":"'+(targetItem < 3)+'"}');
}

// Delete Item
function deleteItem()
{
	if (targetItem > 2) // Allow Deleting Item
	{
		var max = targetObj.attr('data-random-text-string-count');
		var newMax = max-1;

		targetObj.removeAttr('data-random-text-string-'+targetItem); // Remove Old Attr
		targetObj.attr('data-random-text-string-count',newMax); // Store New Max

		for (i = (targetItem+1); i < (max+1); i++) // Loop upper numbered items and reassign new numbers
		{
			var attrVal = targetObj.attr('data-random-text-string-'+i);
			targetObj.attr('data-random-text-string-'+(i-1),attrVal).removeAttr('data-random-text-string-'+i); // Remove Old Attr
		}

		window.webkit.messageHandlers.popUIMenu.postMessage('{"attr":"selected-string-item","items":"'+getMenuItemArray(newMax)+'", "value":"0"}'); // Set Menu Up
		window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"label-data","value":"'+targetObj.text()+'","sync":"false"}'); // Update Text Input Field
		window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes

		window.webkit.messageHandlers.setUIHidden.postMessage('{"attr":"delete-btn","hidden":"true"}'); // Toggle Delete Button
	}
}

// Get Menu Item Array
function getMenuItemArray(newMax)
{
	var menuItemData = '';

	for (i = 0; i < newMax; i++)
	{
  		menuItemData += 'Item '+(i+1)+',';
	}

	menuItemData += 'Add New Item';

	return menuItemData;
}
